=== modified file 'include/core/CMakeLists.txt'
--- include/core/CMakeLists.txt	2012-01-19 06:08:11 +0000
+++ include/core/CMakeLists.txt	2012-01-19 19:16:27 +0000
@@ -10,7 +10,6 @@
     option.h
     output.h
     plugin.h
-    point.h
     propertywriter.h
     privateunion.h
     rect.h

=== modified file 'src/CMakeLists.txt'
--- src/CMakeLists.txt	2012-01-16 09:50:28 +0000
+++ src/CMakeLists.txt	2012-01-19 19:16:27 +0000
@@ -5,6 +5,7 @@
 add_subdirectory( logmessage )
 add_subdirectory( timer )
 add_subdirectory( pluginclasshandler )
+add_subdirectory( point )
 add_subdirectory( wrapsystem/tests )
 
 compiz_add_bcop_targets (
@@ -40,7 +41,9 @@
     
     ${CMAKE_CURRENT_SOURCE_DIR}/pluginclasshandler/include
     ${CMAKE_CURRENT_SOURCE_DIR}/pluginclasshandler/src
-    
+
+    ${CMAKE_CURRENT_SOURCE_DIR}/point/include
+    ${CMAKE_CURRENT_SOURCE_DIR}/point/src    
 )
 
 add_definitions (
@@ -75,7 +78,6 @@
     ${CMAKE_CURRENT_SOURCE_DIR}/output.cpp
     ${CMAKE_CURRENT_SOURCE_DIR}/rect.cpp
     ${CMAKE_CURRENT_SOURCE_DIR}/size.cpp
-    ${CMAKE_CURRENT_SOURCE_DIR}/point.cpp
     ${CMAKE_CURRENT_SOURCE_DIR}/windowgeometry.cpp
     ${CMAKE_CURRENT_SOURCE_DIR}/icon.cpp
     ${CMAKE_CURRENT_SOURCE_DIR}/modifierhandler.cpp
@@ -104,6 +106,7 @@
     compiz_timer
     compiz_logmessage
     compiz_pluginclasshandler
+    compiz_point
 #    ${CORE_MOD_LIBRARIES}
 )
 

=== added directory 'src/point'
=== removed file 'src/point.cpp'
--- src/point.cpp	2010-01-21 16:21:30 +0000
+++ src/point.cpp	1970-01-01 00:00:00 +0000
@@ -1,100 +0,0 @@
-/*
- * Copyright © 2008 Dennis Kasprzyk
- *
- * Permission to use, copy, modify, distribute, and sell this software
- * and its documentation for any purpose is hereby granted without
- * fee, provided that the above copyright notice appear in all copies
- * and that both that copyright notice and this permission notice
- * appear in supporting documentation, and that the name of
- * Dennis Kasprzyk not be used in advertising or publicity pertaining to
- * distribution of the software without specific, written prior permission.
- * Dennis Kasprzyk makes no representations about the suitability of this
- * software for any purpose. It is provided "as is" without express or
- * implied warranty.
- *
- * DENNIS KASPRZYK DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
- * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN
- * NO EVENT SHALL DENNIS KASPRZYK BE LIABLE FOR ANY SPECIAL, INDIRECT OR
- * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
- * OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
- * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
- * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
- *
- * Authors: Dennis Kasprzyk <onestone@compiz-fusion.org>
- */
-
-#include <core/point.h>
-
-CompPoint::CompPoint () :
-   mX (0),
-   mY (0)
-{
-}
-
-CompPoint::CompPoint (int x, int y) :
-   mX (x),
-   mY (y)
-{
-}
-
-void
-CompPoint::set (int x, int y)
-{
-    mX = x;
-    mY = y;
-}
-
-void
-CompPoint::setX (int x)
-{
-    mX = x;
-}
-
-void
-CompPoint::setY (int y)
-{
-    mY = y;
-}
-
-bool
-CompPoint::operator== (const CompPoint &point) const
-{
-    return (mX == point.mX) && (mY == point.mY);
-}
-
-bool
-CompPoint::operator!= (const CompPoint &point) const
-{
-    return !(*this == point);
-}
-
-CompPoint &
-CompPoint::operator+= (const CompPoint &point)
-{
-    mX += point.mX;
-    mY += point.mY;
-
-    return *this;
-}
-
-CompPoint
-CompPoint::operator+ (const CompPoint &rhs) const
-{
-    return CompPoint (mX + rhs.mX, mY + rhs.mY);
-}
-
-CompPoint &
-CompPoint::operator-= (const CompPoint &point)
-{
-    mX -= point.mX;
-    mY -= point.mY;
-
-    return *this;
-}
-
-CompPoint
-CompPoint::operator- (const CompPoint &rhs) const
-{
-    return CompPoint (mX - rhs.mX, mY - rhs.mY);
-}
-

=== added file 'src/point/CMakeLists.txt'
--- src/point/CMakeLists.txt	1970-01-01 00:00:00 +0000
+++ src/point/CMakeLists.txt	2012-01-19 19:16:27 +0000
@@ -0,0 +1,67 @@
+pkg_check_modules (
+  GLIBMM
+  REQUIRED
+  glibmm-2.4 glib-2.0
+)
+
+INCLUDE_DIRECTORIES (  
+  ${CMAKE_CURRENT_SOURCE_DIR}/include
+  ${CMAKE_CURRENT_SOURCE_DIR}/src
+
+  ${CMAKE_CURRENT_SOURCE_DIR}/point/include
+  ${CMAKE_CURRENT_SOURCE_DIR}/point/src
+
+  ${compiz_SOURCE_DIR}/include
+    
+  ${Boost_INCLUDE_DIRS}
+  
+  ${GLIBMM_INCLUDE_DIRS}
+)
+
+LINK_DIRECTORIES (${GLIBMM_LIBRARY_DIRS}) 
+
+SET ( 
+  PUBLIC_HEADERS 
+  ${CMAKE_CURRENT_SOURCE_DIR}/include/core/point.h
+)
+
+SET ( 
+  PRIVATE_HEADERS 
+)
+
+SET( 
+  SRCS 
+  ${CMAKE_CURRENT_SOURCE_DIR}/src/point.cpp
+)
+
+ADD_LIBRARY( 
+  compiz_point STATIC
+  
+  ${SRCS}
+  
+  ${PUBLIC_HEADERS}
+  ${PRIVATE_HEADERS}
+)
+
+ADD_SUBDIRECTORY( ${CMAKE_CURRENT_SOURCE_DIR}/tests )
+
+SET_TARGET_PROPERTIES(
+  compiz_point PROPERTIES
+  PUBLIC_HEADER "${PUBLIC_HEADERS}"
+)
+
+INSTALL(
+  TARGETS                                 compiz_point
+  RUNTIME             DESTINATION         bin
+  LIBRARY             DESTINATION         lib
+  ARCHIVE             DESTINATION         lib
+  PUBLIC_HEADER       DESTINATION         include/compiz
+)
+
+
+
+TARGET_LINK_LIBRARIES( 
+  compiz_point
+  
+  ${GLIBMM_LIBRARIES}
+)

=== added directory 'src/point/include'
=== added directory 'src/point/include/core'
=== added file 'src/point/include/core/point.h'
--- src/point/include/core/point.h	1970-01-01 00:00:00 +0000
+++ src/point/include/core/point.h	2012-01-19 19:16:27 +0000
@@ -0,0 +1,110 @@
+/*
+ * Copyright © 2008 Dennis Kasprzyk
+ *
+ * Permission to use, copy, modify, distribute, and sell this software
+ * and its documentation for any purpose is hereby granted without
+ * fee, provided that the above copyright notice appear in all copies
+ * and that both that copyright notice and this permission notice
+ * appear in supporting documentation, and that the name of
+ * Dennis Kasprzyk not be used in advertising or publicity pertaining to
+ * distribution of the software without specific, written prior permission.
+ * Dennis Kasprzyk makes no representations about the suitability of this
+ * software for any purpose. It is provided "as is" without express or
+ * implied warranty.
+ *
+ * DENNIS KASPRZYK DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
+ * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN
+ * NO EVENT SHALL DENNIS KASPRZYK BE LIABLE FOR ANY SPECIAL, INDIRECT OR
+ * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
+ * OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
+ * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
+ * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ * Authors: Dennis Kasprzyk <onestone@compiz-fusion.org>
+ */
+
+#ifndef _COMPPOINT_H
+#define _COMPPOINT_H
+
+#include <vector>
+#include <list>
+
+/**
+ * A 2D coordinate (likely in screen space) that can only be mutated
+ * through set() methods, since it's data members are private.
+ */
+class CompPoint {
+
+    public:
+	CompPoint ();
+	CompPoint (int, int);
+	
+	/**
+	 * Get the x coordinate of this point
+	 */
+	int x () const;
+	
+	/**
+	 * Get the y coordinate of this point
+	 */
+	int y () const;
+	
+	/**
+	 * Set the x and y coordinate of this point
+	 */
+	void set (int, int);
+	
+	/**
+	 * Set the x coordinate of this point
+	 */
+	void setX (int);
+	
+	/**
+	 * Set the y coordinate of this point
+	 */
+	void setY (int);
+
+	bool operator== (const CompPoint &) const;
+	bool operator!= (const CompPoint &) const;
+	
+	/**
+	 * Takes from both co-ordinates
+	 */
+	CompPoint & operator-= (const CompPoint &);
+	/**
+	 * Adds to both co-ordinates
+	 */
+	CompPoint & operator+= (const CompPoint &);
+	
+	/**
+	 * Retuns an added point
+	 */
+	CompPoint operator+ (const CompPoint &) const;
+	/**
+	 * Returns a subtracted point
+	 */
+	CompPoint operator- (const CompPoint &) const;
+
+	typedef std::vector<CompPoint> vector;
+	typedef std::vector<CompPoint *> ptrVector;
+	typedef std::list<CompPoint> list;
+	typedef std::list<CompPoint *> ptrList;
+
+    private:
+	int mX, mY;
+};
+
+inline int
+CompPoint::x () const
+{
+    return mX;
+}
+
+inline int
+CompPoint::y () const
+{
+    return mY;
+}
+
+
+#endif

=== added directory 'src/point/src'
=== added file 'src/point/src/point.cpp'
--- src/point/src/point.cpp	1970-01-01 00:00:00 +0000
+++ src/point/src/point.cpp	2012-01-19 19:16:27 +0000
@@ -0,0 +1,100 @@
+/*
+ * Copyright © 2008 Dennis Kasprzyk
+ *
+ * Permission to use, copy, modify, distribute, and sell this software
+ * and its documentation for any purpose is hereby granted without
+ * fee, provided that the above copyright notice appear in all copies
+ * and that both that copyright notice and this permission notice
+ * appear in supporting documentation, and that the name of
+ * Dennis Kasprzyk not be used in advertising or publicity pertaining to
+ * distribution of the software without specific, written prior permission.
+ * Dennis Kasprzyk makes no representations about the suitability of this
+ * software for any purpose. It is provided "as is" without express or
+ * implied warranty.
+ *
+ * DENNIS KASPRZYK DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
+ * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN
+ * NO EVENT SHALL DENNIS KASPRZYK BE LIABLE FOR ANY SPECIAL, INDIRECT OR
+ * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
+ * OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
+ * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
+ * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ * Authors: Dennis Kasprzyk <onestone@compiz-fusion.org>
+ */
+
+#include <core/point.h>
+
+CompPoint::CompPoint () :
+   mX (0),
+   mY (0)
+{
+}
+
+CompPoint::CompPoint (int x, int y) :
+   mX (x),
+   mY (y)
+{
+}
+
+void
+CompPoint::set (int x, int y)
+{
+    mX = x;
+    mY = y;
+}
+
+void
+CompPoint::setX (int x)
+{
+    mX = x;
+}
+
+void
+CompPoint::setY (int y)
+{
+    mY = y;
+}
+
+bool
+CompPoint::operator== (const CompPoint &point) const
+{
+    return (mX == point.mX) && (mY == point.mY);
+}
+
+bool
+CompPoint::operator!= (const CompPoint &point) const
+{
+    return !(*this == point);
+}
+
+CompPoint &
+CompPoint::operator+= (const CompPoint &point)
+{
+    mX += point.mX;
+    mY += point.mY;
+
+    return *this;
+}
+
+CompPoint
+CompPoint::operator+ (const CompPoint &rhs) const
+{
+    return CompPoint (mX + rhs.mX, mY + rhs.mY);
+}
+
+CompPoint &
+CompPoint::operator-= (const CompPoint &point)
+{
+    mX -= point.mX;
+    mY -= point.mY;
+
+    return *this;
+}
+
+CompPoint
+CompPoint::operator- (const CompPoint &rhs) const
+{
+    return CompPoint (mX - rhs.mX, mY - rhs.mY);
+}
+

=== added directory 'src/point/tests'
=== added file 'src/point/tests/CMakeLists.txt'
--- src/point/tests/CMakeLists.txt	1970-01-01 00:00:00 +0000
+++ src/point/tests/CMakeLists.txt	2012-01-19 19:16:27 +0000
@@ -0,0 +1,18 @@
+include_directories(${CMAKE_CURRENT_SOURCE_DIR})
+
+add_library (compiz_point_test
+             ${CMAKE_CURRENT_SOURCE_DIR}/test-point.cpp)
+
+add_executable (compiz_test_point
+                ${CMAKE_CURRENT_SOURCE_DIR}/point/src/test-point.cpp)
+
+target_link_libraries (compiz_test_point
+                       compiz_point_test
+                       compiz_point 
+                       ${GTEST_BOTH_LIBRARIES}
+		       ${GMOCK_LIBRARY}
+		       ${GMOCK_MAIN_LIBRARY}
+		       ${CMAKE_THREAD_LIBS_INIT} # Link in pthread. 
+                       )
+
+add_test (compiz_point compiz_test_point)

=== added directory 'src/point/tests/point'
=== added directory 'src/point/tests/point/src'
=== added file 'src/point/tests/point/src/test-point.cpp'
--- src/point/tests/point/src/test-point.cpp	1970-01-01 00:00:00 +0000
+++ src/point/tests/point/src/test-point.cpp	2012-01-19 19:16:27 +0000
@@ -0,0 +1,71 @@
+/*
+ * Copyright © 2011 Canonical Ltd.
+ *
+ * Permission to use, copy, modify, distribute, and sell this software
+ * and its documentation for any purpose is hereby granted without
+ * fee, provided that the above copyright notice appear in all copies
+ * and that both that copyright notice and this permission notice
+ * appear in supporting documentation, and that the name of
+ * Canonical Ltd. not be used in advertising or publicity pertaining to
+ * distribution of the software without specific, written prior permission.
+ * Canonical Ltd. makes no representations about the suitability of this
+ * software for any purpose. It is provided "as is" without express or
+ * implied warranty.
+ *
+ * CANONICAL, LTD. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
+ * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN
+ * NO EVENT SHALL CANONICAL, LTD. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
+ * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
+ * OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
+ * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
+ * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ * Authored by: Sam Spilsbury <sam.spilsbury@canonical.com>
+ */
+
+#include "test-point.h"
+
+class CompPointTestPoint :
+    public CompWindowPointTest
+{
+    public:
+
+	CompPointTestPoint ();
+	~CompPointTestPoint ();
+
+    protected:
+
+	CompPoint p;
+};
+
+CompPointTestPoint::CompPointTestPoint () :
+    p (0, 0)
+{
+}
+
+CompPointTestPoint::~CompPointTestPoint ()
+{
+}
+
+TEST_F (CompPointTestPoint, TestPoint)
+{
+  p.setX (10);
+
+  EXPECT_EQ (p.x (), 10);
+
+  p.setY (10);
+
+  EXPECT_EQ (p.y (), 10);
+  EXPECT_EQ (p, CompPoint (10, 10));
+
+  EXPECT_TRUE (p == CompPoint (10, 10));
+  EXPECT_FALSE (p != CompPoint (10, 10));
+
+  p -= CompPoint (5, 5);
+
+  EXPECT_EQ (p, CompPoint (5, 5));
+
+  p += CompPoint (3, 3);
+
+  EXPECT_EQ (p, CompPoint (8, 8));
+}

=== added file 'src/point/tests/test-point.cpp'
--- src/point/tests/test-point.cpp	1970-01-01 00:00:00 +0000
+++ src/point/tests/test-point.cpp	2012-01-19 19:16:27 +0000
@@ -0,0 +1,34 @@
+/*
+ * Copyright © 2011 Canonical Ltd.
+ *
+ * Permission to use, copy, modify, distribute, and sell this software
+ * and its documentation for any purpose is hereby granted without
+ * fee, provided that the above copyright notice appear in all copies
+ * and that both that copyright notice and this permission notice
+ * appear in supporting documentation, and that the name of
+ * Canonical Ltd. not be used in advertising or publicity pertaining to
+ * distribution of the software without specific, written prior permission.
+ * Canonical Ltd. makes no representations about the suitability of this
+ * software for any purpose. It is provided "as is" without express or
+ * implied warranty.
+ *
+ * CANONICAL, LTD. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
+ * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN
+ * NO EVENT SHALL CANONICAL, LTD. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
+ * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
+ * OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
+ * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
+ * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ * Authored by: Sam Spilsbury <sam.spilsbury@canonical.com>
+ */
+
+#include "test-point.h"
+
+CompWindowPointTest::CompWindowPointTest ()
+{
+}
+
+CompWindowPointTest::~CompWindowPointTest ()
+{
+}

=== added file 'src/point/tests/test-point.h'
--- src/point/tests/test-point.h	1970-01-01 00:00:00 +0000
+++ src/point/tests/test-point.h	2012-01-19 19:16:27 +0000
@@ -0,0 +1,43 @@
+/*
+ * Copyright © 2011 Canonical Ltd.
+ *
+ * Permission to use, copy, modify, distribute, and sell this software
+ * and its documentation for any purpose is hereby granted without
+ * fee, provided that the above copyright notice appear in all copies
+ * and that both that copyright notice and this permission notice
+ * appear in supporting documentation, and that the name of
+ * Canonical Ltd. not be used in advertising or publicity pertaining to
+ * distribution of the software without specific, written prior permission.
+ * Canonical Ltd. makes no representations about the suitability of this
+ * software for any purpose. It is provided "as is" without express or
+ * implied warranty.
+ *
+ * CANONICAL, LTD. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
+ * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN
+ * NO EVENT SHALL CANONICAL, LTD. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
+ * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
+ * OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
+ * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
+ * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ * Authored by: Sam Spilsbury <sam.spilsbury@canonical.com>
+ */
+
+#ifndef _COMPIZ_TEST_WINDOW_GEOMETRY_H
+#define _COMPIZ_TEST_WINDOW_GEOMETRY_H
+
+#include <gtest/gtest.h>
+#include <core/point.h>
+#include <iostream>
+#include <boost/bind.hpp>
+
+class CompWindowPointTest : public ::testing::Test
+{
+public:
+
+    CompWindowPointTest ();
+    virtual ~CompWindowPointTest ();
+
+};
+
+#endif

